#!/usr/bin/env python

import sys
sys.path.append(".")
import soundcard
from soundcard.rat import Rat
import re
tokens = (
 'WHITE',
 'INTEGER',
 'STRING',
 'LBRACE',
 'NAME',
 'RBRACE',
 'EQUALS',
 'DIVIDE',
 'PLUS',
 'PERCENT',
# 'COMMA',
)
for b in ('BLOCKSTART', 'EQUALS_EXP', 'PLUS_EXP', 'DIVIDE_EXP', 'PERCENT_EXP'):
    globals()[b] = b
for t in tokens:
    globals()[t] = t

re_dict = {
  INTEGER: re.compile("\d+"),
  LBRACE: re.compile("{"),
  RBRACE: re.compile("}"),
  WHITE: re.compile("\s+"),
  NAME: re.compile("[a-zA-Z]+"),
  EQUALS: re.compile("="),
  STRING: re.compile("\"[^\"]*\""),
  DIVIDE: re.compile("/"),
  PLUS: re.compile("\+"),
  PERCENT: re.compile("%"),
}

s = r"""
tempo = 60/4
s = "\relative c{%s}"
a = "\addvoice{%s}"
header { 
    title = "En liten tittel"
    subtitle = "Sub" + "tit" + "le"
    numlines = 3
}
question {
   name = "I-II-IV-V-I"
   music = s%"c d e" + a%"f"
}
"""
p = 0
v = []
while p < len(s):
    for t in tokens:
        #print "trying", t
        m = re_dict[t].match(s[p:])
        if m:
            if t == WHITE:
                p = p + m.end()
            else:
                v.append(t, m.group())
                p = p + m.end()
            break
    if not m:
        print "lexer fail. invalid token"
        break

def show_list(list):
    for x in list:
        print x[0]
def do_simple_op(list, op):
    x = 1
    while x < len(list):
        if list[x][0] == op:
            list[x-1:x+2]=[('%s_EXP'%op, list[x-1], list[x+1])]
        else:
            x = x + 1
    return list
def do_blockstart(list):
    x = 0
    while x < len(list):
        if list[x][0] == NAME and list[x+1][0] == LBRACE:
            list[x:x+2]=[('BLOCKSTART', list[x])]
        else:
            x = x + 1
    return list
def evaluate(exp, m_globals):
    #print "eval", exp
    if exp[0] == DIVIDE_EXP:
        return Rat(int(exp[1][1]), int(exp[2][1]))
    elif exp[0] == STRING:
        return exp[1][1:][:-1]
    elif exp[0] == INTEGER:
        return int(exp[1])
    elif exp[0] == PLUS_EXP:
        return evaluate(exp[1], m_globals) + evaluate(exp[2], m_globals)
    elif exp[0] == PERCENT_EXP:
        if exp[1][0] == NAME:
            A = evaluate(exp[1], m_globals)
        else:
            A = exp[1][1]
        return A % exp[2][1][1:][:-1]
    elif exp[0] == NAME:
        return m_globals[exp[1]]
    else:
        pass

for op in (PERCENT, PLUS, DIVIDE, EQUALS):
    v = do_simple_op(v, op)
v = do_blockstart(v)

m_globals = {}
m_blocks = []
context = m_globals
for ex in v:
    if ex[0] == EQUALS_EXP:
        context[ex[1][1]] = evaluate(ex[2], m_globals)
    elif ex[0] == BLOCKSTART:
        assert context == m_globals
        m_blocks.append({})
        context = m_blocks[-1]
        context['blocktype'] = ex[1][1]
    elif ex[0] == RBRACE:
        context = m_globals
    else:
        print "blocks:", m_blocks
        raise "unfinished", ex[0]
print "globals:", m_globals
print "blocks:", m_blocks
